package de.accso.flexinale.besucherportal.api_contract.event;

import com.fasterxml.jackson.annotation.JsonGetter;
import de.accso.flexinale.besucherportal.api_contract.event.model.GutscheinEinloesenAuftragTO;
import de.accso.flexinale.common.api.event.AbstractEvent;
import de.accso.flexinale.common.api.event.Event;
import de.accso.flexinale.common.shared_kernel.DoNotCheckInArchitectureTests;
import de.accso.flexinale.common.shared_kernel.Versionable;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

@SuppressWarnings({"unused", "CanBeFinal"})
public class GutscheinEinloesenBeauftragtEvent extends AbstractEvent implements Event {
    private static Version version = Versionable.initialVersion().inc();

    @DoNotCheckInArchitectureTests
    public GutscheinEinloesenAuftragTO gutscheinEinloesenAuftrag;

    private GutscheinEinloesenBeauftragtEvent() {} // needed for (de)serialization via Jackson

    public GutscheinEinloesenBeauftragtEvent(final GutscheinEinloesenAuftragTO gutscheinEinloesenAuftrag) {
        this.gutscheinEinloesenAuftrag = gutscheinEinloesenAuftrag;
    }

    @Override
    @JsonGetter("version") // needed as otherwise the static field version is not (de)serialized
    public Version version() {
        return version;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        final GutscheinEinloesenBeauftragtEvent that = (GutscheinEinloesenBeauftragtEvent) o;

        return new EqualsBuilder().appendSuper(super.equals(o))
                .append(this.version(), that.version())
                .append(gutscheinEinloesenAuftrag, that.gutscheinEinloesenAuftrag)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .appendSuper(super.hashCode())
                .append(this.version())
                .append(gutscheinEinloesenAuftrag)
                .toHashCode();
    }
}
